## net.sf.saxon.style
Class UseWhenStaticContext

    java.lang.Object
      net.sf.saxon.sxpath.AbstractStaticContext
          net.sf.saxon.style.UseWhenStaticContext

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, Container, StaticContext, XSLTStaticContext

    public class UseWhenStaticContext

extends AbstractStaticContext
implements XSLTStaticContext, Container

This class implements the static context used for evaluating use-when expressions in XSLT 2.0

See Also:
  Serialized Form

Field Summary
`FunctionLibrary` `functionLibrary`
`NamespaceResolver` `namespaceContext`
`StyleNodeFactory` `nodeFactory`

Constructor Summary
`UseWhenStaticContext(Configuration config, NamespaceResolver namespaceContext)` Create a static context for evaluating use-when expressions

Method Summary
`VariableReference` `bindVariable(StructuredQName qName)` Bind a variable used in this element to the XSLVariable element in which it is declared
`StringCollator` `getCollation(java.lang.String name)` Get a named collation.
`java.lang.String` `getDefaultCollationName()` Get the name of the default collation.
`java.lang.String` `getDefaultFunctionNamespace()` Get the default function namespace
`FunctionLibrary` `getFunctionLibrary()` Get the function library containing all the in-scope functions available in this static context
`java.util.Set` `getImportedSchemaNamespaces()` Get the set of imported schemas
`NamespaceResolver` `getNamespaceResolver()` Get a namespace resolver to resolve the namespaces declared in this static context.
`java.lang.String` `getSystemId()` Get the System ID of the container of the expression.
`java.lang.String` `getURIForPrefix(java.lang.String prefix)` Get the URI for a namespace prefix.
`boolean` `isAllowedBuiltInType(BuiltInAtomicType type)` Determine whether a built-in type is available in this context.
`boolean` `isElementAvailable(java.lang.String qname)` Determine if an extension element is available
`boolean` `isImportedSchema(java.lang.String namespace)` Determine whether a Schema for a given target namespace has been imported.
`boolean` `isInBackwardsCompatibleMode()` Determine whether Backwards Compatible Mode is used
`void` `issueWarning(java.lang.String s, javax.xml.transform.SourceLocator locator)` Issue a compile-time warning

Methods inherited from class net.sf.saxon.sxpath.AbstractStaticContext

`addFunctionLibrary, declareCollation, getBaseURI, getColumnNumber, getConfiguration, getDefaultElementNamespace, getExecutable, getHostLanguage, getLineNumber, getLocationMap, getLocationProvider, getNamePool, getPublicId, makeEarlyEvaluationContext, replaceSubExpression, setBackwardsCompatibilityMode, setBaseURI, setConfiguration, setDefaultElementNamespace, setDefaultFunctionLibrary, setDefaultFunctionNamespace, setFunctionLibrary, setLocationMap`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.expr.StaticContext
`getBaseURI, getConfiguration, getDefaultElementNamespace, getLineNumber, getLocationMap, getNamePool, makeEarlyEvaluationContext`

Methods inherited from interface net.sf.saxon.expr.Container
`getExecutable, getHostLanguage, getLocationProvider, replaceSubExpression`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId`

Field Detail

### namespaceContext

    public NamespaceResolver namespaceContext

### functionLibrary

    public FunctionLibrary functionLibrary

### nodeFactory

    public StyleNodeFactory nodeFactory

Constructor Detail

### UseWhenStaticContext

    public UseWhenStaticContext(Configuration config,
                                NamespaceResolver namespaceContext)

  Create a static context for evaluating use-when expressions

  Parameters:
    `config` - the Saxon configuration
    `namespaceContext` - the namespace context in which the use-when expression appears

Method Detail

### issueWarning

    public void issueWarning(java.lang.String s,
                             javax.xml.transform.SourceLocator locator)

  Issue a compile-time warning

  Specified by:
    `issueWarning` in interface `StaticContext`
  Overrides:
    `issueWarning` in class `AbstractStaticContext`
  Parameters:
    `s` - The warning message. This should not contain any prefix such as "Warning".
    `locator` - the location of the construct in question. May be null.

### getSystemId

    public java.lang.String getSystemId()

  Get the System ID of the container of the expression. This is the containing entity (file) and is therefore useful for diagnostics. Use getBaseURI() to get the base URI, which may be different.

  Specified by:
    `getSystemId` in interface `javax.xml.transform.SourceLocator`
  Specified by:
    `getSystemId` in interface `StaticContext`
  Overrides:
    `getSystemId` in class `AbstractStaticContext`
  Returns:
    "" always

### getURIForPrefix

    public java.lang.String getURIForPrefix(java.lang.String prefix)
                                     throws XPathException

  Get the URI for a namespace prefix. The default namespace is NOT used when the prefix is empty.

  Specified by:
    `getURIForPrefix` in interface `StaticContext`
  Parameters:
    `prefix` - The prefix
  Returns:
    the corresponding namespace URI
  Throws:
    `XPathException` - if the prefix is not declared

### bindVariable

    public VariableReference bindVariable(StructuredQName qName)
                                   throws XPathException

  Bind a variable used in this element to the XSLVariable element in which it is declared

  Specified by:
    `bindVariable` in interface `StaticContext`
  Parameters:
    `qName` - the name of the variable
  Returns:
    a VariableReference representing the variable reference, suitably initialized to refer to the corresponding variable declaration
  Throws:
    `XPathException`

### getFunctionLibrary

    public FunctionLibrary getFunctionLibrary()

  Get the function library containing all the in-scope functions available in this static context

  Specified by:
    `getFunctionLibrary` in interface `StaticContext`
  Overrides:
    `getFunctionLibrary` in class `AbstractStaticContext`
  Returns:
    the function library

### getCollation

    public StringCollator getCollation(java.lang.String name)

  Get a named collation.

  Specified by:
    `getCollation` in interface `StaticContext`
  Overrides:
    `getCollation` in class `AbstractStaticContext`
  Parameters:
    `name` - The name of the required collation. Supply null to get the default collation.
  Returns:
    the collation; or null if the required collation is not found.

### getDefaultCollationName

    public java.lang.String getDefaultCollationName()

  Get the name of the default collation.

  Specified by:
    `getDefaultCollationName` in interface `StaticContext`
  Overrides:
    `getDefaultCollationName` in class `AbstractStaticContext`
  Returns:
    the name of the default collation; or the name of the codepoint collation if no default collation has been defined

### getDefaultFunctionNamespace

    public java.lang.String getDefaultFunctionNamespace()

  Get the default function namespace

  Specified by:
    `getDefaultFunctionNamespace` in interface `StaticContext`
  Overrides:
    `getDefaultFunctionNamespace` in class `AbstractStaticContext`
  Returns:
    the default namesapce for functions

### isInBackwardsCompatibleMode

    public boolean isInBackwardsCompatibleMode()

  Determine whether Backwards Compatible Mode is used

  Specified by:
    `isInBackwardsCompatibleMode` in interface `StaticContext`
  Overrides:
    `isInBackwardsCompatibleMode` in class `AbstractStaticContext`
  Returns:
    true if XPath 1.0 backwards compatibility has been selected (by default, it is false)

### isImportedSchema

    public boolean isImportedSchema(java.lang.String namespace)

  Determine whether a Schema for a given target namespace has been imported. Note that the in-scope element declarations, attribute declarations and schema types are the types registered with the (schema-aware) configuration, provided that their namespace URI is registered in the static context as being an imported schema namespace. (A consequence of this is that within a Configuration, there can only be one schema for any given namespace, including the null namespace).

  Specified by:
    `isImportedSchema` in interface `StaticContext`
  Parameters:
    `namespace` - the target namespace in question
  Returns:
    true if the given namespace has been imported

### getImportedSchemaNamespaces

    public java.util.Set getImportedSchemaNamespaces()

  Get the set of imported schemas

  Specified by:
    `getImportedSchemaNamespaces` in interface `StaticContext`
  Returns:
    a Set, the set of URIs representing the names of imported schemas

### isAllowedBuiltInType

    public boolean isAllowedBuiltInType(BuiltInAtomicType type)

  Determine whether a built-in type is available in this context. This method caters for differences between host languages as to which set of types are built in.

  Specified by:
    `isAllowedBuiltInType` in interface `StaticContext`
  Overrides:
    `isAllowedBuiltInType` in class `AbstractStaticContext`
  Parameters:
    `type` - the supposedly built-in type. This will always be a type in the XS or XDT namespace.
  Returns:
    true if this type can be used in this static context

### getNamespaceResolver

    public NamespaceResolver getNamespaceResolver()

  Get a namespace resolver to resolve the namespaces declared in this static context.

  Specified by:
    `getNamespaceResolver` in interface `StaticContext`
  Returns:
    a namespace resolver.

### isElementAvailable

    public boolean isElementAvailable(java.lang.String qname)
                               throws XPathException

  Determine if an extension element is available

  Specified by:
    `isElementAvailable` in interface `XSLTStaticContext`
  Throws:
    `XPathException` - if the name is invalid or the prefix is not declared

Copyright (c) Saxonica Limited. All rights reserved.